//@author  Ajit Jagtap
//@version Wed Jul 04 2018 20:15:13 GMT+0530 (IST)

package dalmdl

import (
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestGetDAO(t *testing.T) {
	assert.NotNil(t, GetDAO(), "GetDAO should return not nil value ")
}

func TestDAOBuilder_FilePath(t *testing.T) {
	filePath := "This is file path "
	dao := GetDAO().FilePath(filePath)
	assert.Equal(t, filePath, dao.filePath, "This should return same filepath")
	dao.IsCacheable()
	assert.Equal(t, true, dao.isCacheable, "This should return cache is true")
	query := []string{"some query", "2nd query"}
	dao.Query("some query", "2nd query")
	assert.Len(t, query, 2, "This should return len as 2")

}
func TestDAOBuilder_RunNormal(t *testing.T) {
	filePathvar := "../../testingdata/users.json"
	dao, _ := GetDAO().FilePath(filePathvar).Query("*").Run()
	assert.NotEmpty(t, dao.Value, "Check if result is not empty")

	dao, _ = GetDAO().FilePath(filePathvar).Query("*", "#[isEnabled==false]#").Run()
	assert.NotEmpty(t, dao.Value, "Check if result is not empty for mutiple query")

}
